;##########################################################################
;PAL-SECAM TV DEMO tester 
;         
;  .   ,   
;  ,  ,   
;       
;. , 
; 7  PIC16F84-04p (  -     PAL)
;      test5 
;XC=8.867238 Mhz    2
;.  =0.902 mkS, .   =71  
;
;##########################################################################
	
	list      p=16f84	; list directive to define processor
	#include <p16f84.inc>	; processor specific variable definitions
	__CONFIG   _XT_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF

indf	equ	00h
tmr0	equ	01h
pcl	equ	02h
status	equ	03h
fsr	equ	04h	
portA	equ	05h
portB	equ	06h
eedata	equ	08h	
eeadr	equ	09h	
pclath	equ	0Ah
intcon	equ	0Bh

optionr	equ	01h	;81h
trisA	equ	05h	;85h
trisB	equ	06h	;86h
eecon1	equ	08h	;88h
eecon2	equ	09h	;89h

z	equ	2
c	equ	0
Rd	equ	0
Wr	equ	1

;-------------------------------------------------------------------------
; 
sh	equ	0Ch	; 
sl	equ	0Dh	; 
ph	equ	0Eh	; 
pl	equ	0Fh	; 
tt	equ	10h	;
tc	equ	11h	;
tn	equ	12h	;
th	equ	13h	;
tl	equ	14h	;
nh	equ	15h	;
nl	equ	16h	;
nn	equ	17h	; 

;-------------------------------------------------------------------------
; 
ktmr0	equ	.207	;  -  (207/54/0.902=4,250)
nomr	equ	1

;   
PalB	equ	0	; 
PalR	equ	1	; 
PalG	equ	2	; 
Stb	equ	3	; 
; 	4-7	;   

;   
FH2	equ	0	; 
Sync	equ	1	;
Secam	equ	2	;  
AFC	equ	3	; 
Fsec	equ	4	;   

;###############################################################
	org	00h	;
	nop		
	goto	start	
;----------------------------------------------------------------
	org	04h	;
intpr	nop	
	retfie
;----------------------------------------------------------------
;  
start	call	init
	movf	eeadr,w	;   eeadr
	xorlw	nomr	; c 01h
	btfss	status,z
	goto	tree	;   ,   
	movlw	nomr	;  ,   Reset
	call	rdb	;     EEPROM
	addlw	01h	;   
	andlw	07h	;  8-
	call	wrb	;   EEPROM
tree	movlw	nomr
	call	rdb	;     EEPROM
	andlw	07h	;  8-
	addwf	pcl,f	;       EEPROM
	goto	test0	;    PAL
	goto	test1	;  
	goto	test2	;  
	goto	test3	;  
	goto	test4	;  
	goto	test5	; 
	goto	test6	;  
	goto	test7	;   
	goto	start	
	
;----------------------------------------------------------------
; /    ROM
;   W- ,   W-
rdb	movwf	eeadr
	bsf	status,5
	bsf	eecon1,Rd
	bcf	status,5
	movf	eedata,w	;   W
	return
;----------------------------------------------------------------
; /    EEPROM
;    EEADR, W=EEDATA
wrb	movwf eedata
write	bsf	status,5
	bsf	eecon1,2	;WREN=1  
	bcf	eecon1,4	;EEIF clear
	movlw	055h
	movwf	eecon2
	movlw	0AAh
	movwf	eecon2
	bsf	eecon1,Wr
wee    	btfss	eecon1,4	;EEIF   
	goto	wee
	bcf	eecon1,2	;WREN=0  
        bcf	status,5
	return
;----------------------------------------------------------------
;  
init	bsf	status,5
	movlw	b'11111111'	; -  PA4,   Wdt 1:128,
	movwf	optionr		;  ,
	movlw	b'00010000'	; A4-  
	movwf	trisA		;  A -  
	movlw	00h		; 
	movwf	trisB		;   -  
	bcf	status,5
	clrf	intcon		;  
	movlw	85h
	movwf	fsr		; trisA
	clrf	portA
	clrf	portB
	return
;----------------------------------------------------------------
; /     0,3 , =W x 1.3mS
;   w=,  ph, pl
pauseH	movwf	ph	; 
pause1	clrw
	call	pause
	decfsz	ph,f
	goto	pause1
	return
;----------------------------------------------------------------
;  /     1.3 mS, T=W x 5mkS
;    w=,   pl
pause	movwf	pl	; 
pause2	nop
	decfsz	pl,f
	goto	pause2
	return
;----------------------------------------------------------------
; /   
; 4...10 
tt10	nop
tt9	nop
tt8	nop
tt7	nop
tt6	nop
tt5	nop
tt4	return
;----------------------------------------------------------------
; /    
;   W=N  nn
;   5+3N 
ttn2	nop		;5+3N+2
ttn1	nop		;5+3N+1
ttn	movwf	nn	;5+3N
ttn0	decfsz	nn,f
	goto	ttn0
	return

;----------------------------------------------------------------
;     PAL

test0	bcf	portA,1	; sync=0  
	movlw	01h	; bit 0
	xorwf	portA,f	; FH/2
	nop
	nop
	bsf	portA,1	; sync=1  
	nop
	bsf	portB,3	; stb=1  
	nop
	bcf	portB,3	; stb=0  
	movlw	07h	;  
line_c	movwf	portB
	nop
	nop
	nop
color	decfsz	portB,w	; next color
	goto	line_c
	nop
	nop
	clrf	portB	; blank
	call	tt7
	goto	test0	;  

;----------------------------------------------------------------
;   e

test1	
lineG	bcf	portA,1	; sync=0  
	movlw	01h	; bit 0
	xorwf	portA,f	; FH/2
	nop
	nop
	bsf	portA,1	; sync=1  
	nop
	bsf	portB,3	; stb=1  
	nop
	bcf	portB,3	; stb=0  
	movlw	04h	;  
	movwf	portB
	movlw	.17
	call	ttn	;56 
	clrf	portB	; blank

	goto	lineG
	
;----------------------------------------------------------------
;   

test2	
lineR	bcf	portA,1	; sync=0  
	movlw	01h	; bit 0
	xorwf	portA,f	; FH/2
	nop
	nop
	bsf	portA,1	; sync=1  
	nop
	bsf	portB,3	; stb=1  
	nop
	bcf	portB,3	; stb=0  
	movlw	02h	;  
	movwf	portB
	movlw	.17
	call	ttn	;56 
	clrf	portB	; blank
	
	goto	lineR

;----------------------------------------------------------------
;   

test3	
lineB	bcf	portA,1	; sync=0  
	movlw	01h	; bit 0
	xorwf	portA,f	; FH/2
	nop
	nop
	bsf	portA,1	; sync=1  
	nop
	bsf	portB,3	; stb=1  
	nop
	bcf	portB,3	; stb=0  
	movlw	01h	;  
	movwf	portB
	movlw	.17
	call	ttn	;56 
	clrf	portB	; blank
	
	goto	lineB

;----------------------------------------------------------------
;   

test4		
ksi41	bcf	portA,1	; =0 5mkS	;1T
	call	tt4	;
	bsf	portA,1	; =1
	clrf	portB	; blank
	movlw	.18	;  
	call	ttn2	;		59+2 
	movlw	.5	; 5   (2.5 )
	movwf	tt	;		71T
ksi42	bsf	portA,1	; =1 2mkS	1T
	nop
	bcf	portA,1	; =0
	movlw	.8	;
	call	ttn	;		29 
	decfsz	tt,f
	goto	ksi42	;		35T x5
	nop
	bsf	portA,1	; =1 	1T
	movlw	.6	;   
	call	ttn1	;		26T		
	
	movlw	.48
	movwf	th
	movwf	tl
	movlw	.4
	movwf	tc
	movlw	.3
	movwf	tn	
	movlw	.20
	movwf	tt	
	
kgi43	bcf	portA,1	; (20   + )
	call	tt4	;  5mkS
	bsf	portA,1	;
	clrf	portB	; blank
	movlw	.18	;
	call	ttn2	; 59 
	decfsz	tt,f	; 20 
	goto	kgi43	; 
	nop
	
ch10	bcf	portA,1	; 48 - 8 - 
	call	tt4
	bsf	portA,1	; CC=5mkS	5T
	movlw	04
	movwf	tc	
ch11	nop
	movlw	.48
	movwf	tl
	decf	portB,f	;		12T
	call	tt6	
	clrf	portB	;	
	decfsz	tc,f	;4 
	goto	ch11
	call	tt5
	decfsz	th,f	;48 
	goto	ch10
	nop		
	
ch20	bcf	portA,1	; 48 - 8 - 
	call	tt4
	bsf	portA,1	; CC=5mkS
	movlw	04
	movwf	tc
ch21	nop
	movlw	.48
	movwf	th
	clrf	portB	;		12
	call	tt6
	decf	portB,f	; 
	decfsz	tc,f	;4 
	goto	ch21
	call	tt4		
	clrf	portB	;	
	decfsz	tl,f	;48 
	goto	ch20
	nop

ch30	bcf	portA,1	; 48 - 8 - 
	call	tt4
	bsf	portA,1	; CC=5mkS	5T
	movlw	04
	movwf	tc	
ch31	nop
	movlw	.48
	movwf	tl
	decf	portB,f	;		12T
	call	tt6	
	clrf	portB	;	
	decfsz	tc,f	;4 
	goto	ch31
	call	tt5
	decfsz	th,f	;48 
	goto	ch30
	nop		
	
ch40	bcf	portA,1	; 48 - 8 - 
	call	tt4
	bsf	portA,1	; CC=5mkS
	movlw	04
	movwf	tc
ch41	nop
	movlw	.48
	movwf	th
	clrf	portB	;		12
	call	tt6
	decf	portB,f	; 
	decfsz	tc,f	;4 
	goto	ch41
	call	tt4		
	clrf	portB	;	
	decfsz	tl,f	;48 
	goto	ch40
	nop

ch50	bcf	portA,1	; 48 - 8 - 
	call	tt4
	bsf	portA,1	; CC=5mkS	5T
	movlw	04
	movwf	tc	
ch51	nop
	movlw	.48
	movwf	tl
	decf	portB,f	;		12T
	call	tt6	
	clrf	portB	;	
	decfsz	tc,f	;4 
	goto	ch51
	call	tt5
	decfsz	th,f	;48 
	goto	ch50
	nop		
	
ch60	bcf	portA,1	; 48 - 8 - 
	call	tt4
	bsf	portA,1	; CC=5mkS
	movlw	04
	movwf	tc
ch61	nop
	movlw	.48
	movwf	th
	clrf	portB	;		12
	call	tt6
	decf	portB,f	; 
	decfsz	tc,f	;4 
	goto	ch61
	call	tt4		
	clrf	portB	;	
	decfsz	tl,f	;48 
	goto	ch60
	
	goto	test4

;------------------------------------------------------------------
;   

test5
			;     ( 4 )
ksi5	bcf	portA,1	; =0 	1T
	call	tt4	;
	bsf	portA,1	; =1 5mkS	5T
	clrf	portB	; blank
	movlw	.18	;  
	call	ttn2	;		59+2 
	movlw	.5	; 5   (2.5 )
	movwf	tt	;		71T
ksi52	bsf	portA,1	; =1 	1T
	nop
	bcf	portA,1	; =0 2mkS	5T
	movlw	.8	;
	call	ttn	;		29T
	decfsz	tt,f
	goto	ksi52	;		35T x 5
	nop
	bsf	portA,1	; =1 	1T
	movlw	.7	;   
	call	ttn	;		26T		
	
	movlw	.141
	movwf	th
	movwf	tl
	movlw	.6
	movwf	tc
	movlw	.20
	movwf	tn	
			; K 1600mkS
kgi51	bcf	portA,1	; (20   + )
	call	tt4	;  5mkS
	bsf	portA,1	;
	clrf	portB	; blank
	movlw	.18	;
	call	ttn2	; 59 
	decfsz	tn,f	; 20 
	goto	kgi51	; 
	nop
	
kr0	bcf	portA,1	;
	call	tt4	; 5mkS
	bsf	portA,1	;
	movlw	.9	;*
	call	ttn	;29+7 
	decf	portB,f	; 
	clrf	portB	;blank
	movlw	.7	;*
	call	ttn2	;29 
	decfsz	th,f	;141 a
	goto	kr0
	nop

lw5	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.16
	call	ttn2	;53 
	clrf	portB	;blank
	decfsz	tc,f	;6 
	goto	lw5
	nop	
	
kr2	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	movlw	.9	;*
	call	ttn	;29+7 
	decf	portB,f	; 
	clrf	portB	;blank
	movlw	.7	;*
	call	ttn2	;29 
	decfsz	tl,f	;141 a
	goto	kr2
	
	goto	test5

;-------------------------------------------------------------------
;   

test6	
ksi61	bcf	portA,1	; =0 5mkS	;1T
	call	tt4	;
	bsf	portA,1	; =1
	clrf	portB	; blank
	movlw	.18	;  
	call	ttn2	;		59+2 
	movlw	.5	; 5   (2.5 )
	movwf	tt	;		71T
ksi62	bsf	portA,1	; =1 2mkS	1T
	nop
	bcf	portA,1	; =0
	movlw	.8	;
	call	ttn	;		29 
	decfsz	tt,f
	goto	ksi62	;		35T x5
	nop
	bsf	portA,1	; =1 	1T
	movlw	.6	;   
	call	ttn1	;		26T		
	
	movlw	.42
	movwf	th
	movwf	tl
	movlw	.7
	movwf	tc
	movlw	.6
	movwf	tn	
	movlw	.20
	movwf	tt	
	
kgi63	bcf	portA,1	; (20   + )
	call	tt4	;  5mkS
	bsf	portA,1	;
	clrf	portB	; blank
	movlw	.18	;
	call	ttn2	; 59 
	decfsz	tt,f	; 20 
	goto	kgi63	; 
	nop
		
crs01	bcf	portA,1	; 42 - 7 . 
	movlw	.6
	movwf	tt
	movlw	.7
	movwf	tc
	bsf	portA,1	; CC=5mkS	5T	
	clrf	portB	;		
	call	tt8
crs02	nop
	nop
	decf	portB,f	; 	12T
	clrf	portB	;blank
	decfsz	tc,f	;7 
	goto	crs02
	call	tt5		
	decfsz	th,f	;42 
	goto	crs01
	nop
crsw1	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.42
	movwf	th	
	movlw	.16
	call	ttn	;53 
	clrf	portB	;blank
	decfsz	tt,f	;6 
	goto	crsw1
	nop
	
crs21	bcf	portA,1	; 42 - 7 . 
	movlw	.6
	movwf	tt
	movlw	.7
	movwf	tc
	bsf	portA,1	; CC=5mkS	5T	
	clrf	portB	;		
	call	tt8
crs22	nop
	nop
	decf	portB,f	; 	12T
	clrf	portB	;blank
	decfsz	tc,f	;7 
	goto	crs22
	call	tt5		
	decfsz	th,f	;42 
	goto	crs21
	nop
crsw2	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.42
	movwf	th	
	movlw	.16
	call	ttn	;53 
	clrf	portB	;blank
	decfsz	tt,f	;6 
	goto	crsw2
	nop
		
crs31	bcf	portA,1	; 42 - 7 . 
	movlw	.6
	movwf	tt
	movlw	.7
	movwf	tc
	bsf	portA,1	; CC=5mkS	5T	
	clrf	portB	;		
	call	tt8
crs32	nop
	nop
	decf	portB,f	; 	12T
	clrf	portB	;blank
	decfsz	tc,f	;7 
	goto	crs32
	call	tt5		
	decfsz	th,f	;42 
	goto	crs31
	nop
crsw3	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.42
	movwf	th	
	movlw	.16
	call	ttn	;53 
	clrf	portB	;blank
	decfsz	tt,f	;6 
	goto	crsw3
	nop
		
crs41	bcf	portA,1	; 42 - 7 . 
	movlw	.6
	movwf	tt
	movlw	.7
	movwf	tc
	bsf	portA,1	; CC=5mkS	5T	
	clrf	portB	;		
	call	tt8
crs42	nop
	nop
	decf	portB,f	; 	12T
	clrf	portB	;blank
	decfsz	tc,f	;7 
	goto	crs42
	call	tt5		
	decfsz	th,f	;42 
	goto	crs41
	nop
crsw4	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.42
	movwf	th	
	movlw	.16
	call	ttn	;53 
	clrf	portB	;blank
	decfsz	tt,f	;6 
	goto	crsw4
	nop
		
crs51	bcf	portA,1	; 42 - 7 . 
	movlw	.6
	movwf	tt
	movlw	.7
	movwf	tc
	bsf	portA,1	; CC=5mkS	5T	
	clrf	portB	;		
	call	tt8
crs52	nop
	nop
	decf	portB,f	; 	12T
	clrf	portB	;blank
	decfsz	tc,f	;7 
	goto	crs52
	call	tt5		
	decfsz	th,f	;42 
	goto	crs51
	nop
crsw5	bcf	portA,1	; 
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.42
	movwf	th	
	movlw	.16
	call	ttn	;53 
	clrf	portB	;blank
	decfsz	tt,f	;6 
	goto	crsw5
	nop
	
crs61	bcf	portA,1	; 42 - 7 . 
	movlw	.6
	movwf	tt
	movlw	.7
	movwf	tc
	bsf	portA,1	; CC=5mkS	5T	
	clrf	portB	;		
	call	tt8
crs62	nop
	nop
	decf	portB,f	; 	12T
	clrf	portB	;blank
	decfsz	tc,f	;7 
	goto	crs62
	call	tt5		
	decfsz	th,f	;42 
	goto	crs61
	nop
crsw6	bcf	portA,1	;6  
	call	tt4	; 5mkS
	bsf	portA,1	;
	call	tt5	; 6mkS
	decf	portB,f	; 
	movlw	.42
	movwf	th	
	movlw	.16
	call	ttn	;53 
	clrf	portB	;blank
	decfsz	tt,f	;6 
	goto	crsw6
		
	goto	test6

;--------------------------------------------------------------------
;     

test7	
			;     ( 4 )
ksi7	bcf	portA,1	; =0 5mkS	;1T
	call	tt4	;
	bsf	portA,1	; =1
	clrf	portB	; blank
	movlw	.18	;  
	call	ttn2	;		59+2 
	movlw	.5	; 5   (2.5 )
	movwf	tt	;		71T
ksi71	bsf	portA,1	; =1 2mkS	1T
	nop
	bcf	portA,1	; =0
	movlw	.8	;
	call	ttn	;		29 
	decfsz	tt,f
	goto	ksi71	;		35T x5
	nop
	bsf	portA,1	; =1 	1T
	movlw	.6	;   
	call	ttn1	;		26T		
	
	movlw	.144	
	movwf	th
	movwf	tl
	movlw	.5
	movwf	tc
	movlw	.8
	movwf	tn	;		71T
	movlw	.2
	movwf	tt

kgi71	bcf	portA,1	; 2  a
	movlw	60h	
	movwf	portB	; blanc B
	nop
	nop 
	bsf	portA,1	;  5mkS
	bsf	portA,2	;   secam
	call	tt4
	bcf	portA,2	;   secam
	movlw	.17
	call	ttn2	; 58 
	nop
	bcf	portA,1	; 1  
	movlw	80h	
	movwf	portB	; blanc R
	nop
	nop 
	bsf	portA,1	;  5mkS
	bsf	portA,2	;   secam
	call	tt4
	bcf	portA,2	;   secam
	movlw	.17
	call	ttn2	; 58 
	nop
	
kgc7	bcf	portA,1	; 10    
	movlw	60h	
	movwf	portB	; blanc B
	nop
	nop 
	bsf	portA,1	;  5mkS
	bsf	portA,2	;   secam
	call	tt4
	movlw	20h	
	movwf	portB	; B-e  
	movlw	.17
	call	ttn	; 56 
	bcf	portA,2	;   secam
	nop

	bcf	portA,1	; 8  
	movlw	80h	
	movwf	portB	; blanc R
	nop
	nop 
	bsf	portA,1	;  5mkS
	bsf	portA,2	;   secam
	call	tt4
	movlw	0D0h	
	movwf	portB	; R-e  
	movlw	.16
	call	ttn1	; 54 
	bcf	portA,2	;   secam
	decfsz	tc,f
	goto	kgc7
	nop

kgi72	bcf	portA,1	; 8  
	movlw	60h	
	movwf	portB	; blanc B
	nop
	nop 
	bsf	portA,1	;  5mkS
	bsf	portA,2	;   secam
	call	tt4
	bcf	portA,2	;   secam
	movlw	.17
	call	ttn2	; 58 
	nop
	bcf	portA,1	; 8  
	movlw	80h	
	movwf	portB	; blanc R
	nop
	nop 
	bsf	portA,1	;  5mkS
	bsf	portA,2	;   secam
	call	tt4
	bcf	portA,2	;   secam
	movlw	.17
	call	ttn	; 56 
	decfsz	tn,f
	goto	kgi72
	nop
	
secB	bcf	portA,1	; =0
	movlw	60h	
	movwf	portB	; blanc B
	nop
	nop
	bsf	portA,1	;  = 5mkS		5T
	bsf	portA,2	;   secam
	call	tt4
	movlw	6Fh
	movwf	portB	;  		12T
	call	tt4
	movlw	3Fh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	7Eh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	4Dh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	8Ch
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	5Bh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	9Ah
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt5
	movlw	60h
	movwf	portB	;  		61T
	call	tt7
	bcf	portA,2	;   secam
	nop		;			71T

secR	bcf	portA,1	;  5mkS
	movlw	80h	
	movwf	portB	; blanc B
	nop
	nop
	bsf	portA,1	;			5T
	bsf	portA,2	;   secam
	call	tt4
	movlw	8Fh
	movwf	portB	;  		12T
	call	tt4
	movlw	7Fh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	0CEh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	0BDh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	5Ch
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	4Bh
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt4
	movlw	9Ah
	movwf	portB	;  
	decf	portB,f	;  .    
	call	tt5
	movlw	80h
	movwf	portB	;  		61T
	call	tt5
	bcf	portA,2	;   secam
	decfsz	th,f
	goto	secB
	
	goto	test7


;---------------------------------------------------------------------
	end
